cabal-version: 2.4
name: basalt
version: 0.1.0.0
synopsis: version control for Nix configuration
-- description:
-- bug-reports:
license: BSD-3-Clause
license-file: LICENSE
author: Obsidian Systems LLC
maintainer: dev@obsidian.systems
copyright: Obsidian Systems LLC 2020-2022
category: System
extra-source-files:
  README.md
  CHANGELOG.md

library
  exposed-modules:
    Basalt
    Basalt.Version
    Basalt.Version.TH
  default-extensions:
    ApplicativeDo
    BlockArguments
    ConstraintKinds
    DataKinds
    DeriveGeneric
    DeriveTraversable
    EmptyCase
    ExplicitForAll
    FlexibleContexts
    FlexibleInstances
    FunctionalDependencies
    GADTs
    GeneralizedNewtypeDeriving
    LambdaCase
    LiberalTypeSynonyms
    MultiParamTypeClasses
    MultiWayIf
    NumericUnderscores
    OverloadedStrings
    PatternSynonyms
    ScopedTypeVariables
    TypeApplications
    TypeFamilies
    TypeOperators
    ViewPatterns

  build-depends:
      base >=4.12 && < 4.21
    , cli-extras < 0.3
    , containers >= 0.6 && < 0.8
    , directory ^>=1.3.3.0
    , exceptions
    , filepath >=1.4.2.1 && < 1.6
    , lens
    , logging-effect
    , mtl >= 2.2.2 && < 2.4
    , nix-thunk
    , process
    , text
    , template-haskell
    , temporary
    , unix
    , which

  hs-source-dirs:
    src/lib
  default-language:
    Haskell2010
  ghc-options:
    -Wall
    -Werror


executable basalt
  main-is:
    Main.hs
  default-extensions:
    ApplicativeDo
    BlockArguments
    ConstraintKinds
    DataKinds
    DeriveGeneric
    DeriveTraversable
    EmptyCase
    ExplicitForAll
    FlexibleContexts
    FlexibleInstances
    FunctionalDependencies
    GADTs
    GeneralizedNewtypeDeriving
    LambdaCase
    LiberalTypeSynonyms
    MultiParamTypeClasses
    MultiWayIf
    NumericUnderscores
    OverloadedStrings
    PatternSynonyms
    ScopedTypeVariables
    TypeApplications
    TypeFamilies
    TypeOperators
    ViewPatterns

  build-depends:
      base >= 4.12 && < 4.21
    , basalt
    , containers >= 0.6 && < 0.8
    , directory ^>=1.3.3.0
    , filepath >=1.4.2.1 && < 1.6
    , optparse-applicative >= 0.14.3.0 && <0.19

  hs-source-dirs:
    src/app
  default-language:
    Haskell2010
  ghc-options:
    -Wall
    -Werror
    -threaded
